void printc ( char c ) ;

void print ( int board [ ] [ 8 ] ) {
   for ( int i = 0 ; i < 8 ; i ++ ) {
      for ( int j = 0 ; j < 8 ; j ++ ) printc ( board [ i ] [ j ] ? '*' : '.' ) ;
      printc ( 10 ) ;
   }
   printc ( 10 ) ;
}

int conflict ( int board [ ] [ 8 ] , int row , int col ) {
   for ( int i = 0 ; i < row ; i ++ ) {
      if ( board [ i ] [ col ] ) return 1 ;
      int j = row - i ;
      if ( j < col + 1 && board [ i ] [ col - j ] ||
           col + j < 8 && board [ i ] [ col + j ] ) return 1 ;
   }
   return 0 ;
}

void solve ( int board [ ] [ 8 ] , int row ) {
   if ( row - 8 ) for ( int j = 0 ; j < 8 ; j ++ ) {
      if ( ! conflict ( board , row , j ) ) {
         board [ row ] [ j ] = 1 ;
         solve ( board , row + 1 ) ;
         board [ row ] [ j ] = 0 ;
      }
   }
   else print ( board ) ;
}

int board [ 64 ] , i ;

void main ( ) {
   for ( i = 0 ; i < 64 ; i ++ ) board [ i ] = 0 ;
   solve ( board , 0 ) ;
}