void printc ( char c ) ;
void printn ( int n ) ;
void prints ( char * s ) ;

void expect ( int a , int b ) {
   if ( a == b ) return ;
   printn ( a ) ; printc ( ':' ) ; printn ( b ) ;
   prints ( ": " ) ;
   printn ( a ) ; prints ( " expected, but got " ) ; printn ( b ) ;
   printc ( 10 ) ;
}

int <%> ( int a , int b ) {
   return a - ( a / b ) * b ;
}

int + ( int a , int b ) {
   return a - ( - b ) ;
}

void cr ( ) `10 printc`

void done ( ) {
   prints ( "done" ) ;
   `cr`
}

static void test_basic ( ) {
   prints ( "basic" ) ; cr ( ) ;
   expect ( 0 , 0 ) ;
   expect ( 3 , 1 + 2 ) ;
   expect ( 3 , 1 + 2 ) ;
   expect ( 10 , 1 + 2 + 3 + 4 ) ;
   expect ( 11 , 1 + 2 * 3 + 4 ) ;
   expect ( 14 , 1 * 2 + 3 * 4 ) ;
   expect ( 4 , 4 / 2 + 6 / 3 ) ;
   expect ( 4 , 24 / 2 / 3 ) ;
   expect ( 3 , 24 % 7 ) ;
   expect ( 0 , 24 % 3 ) ;
   expect ( 98 , 'a' + 1 ) ;
   int a = 0 - 1 ;
   expect ( 0 - 1 , a ) ;
   expect ( - 1 , a ) ;
   expect ( 0 , a + 1 ) ;
   expect ( 1 , + 1 ) ;
   "expect ( 1 , ( unsigned ) 4000000001 % 2 )" ;
   done ( ) ;
}

static void test_relative ( ) {
   prints ( "relative" ) ; cr ( ) ;
   expect ( 1 , 1 > 0 ) ;
   expect ( 1 , 0 < 1 ) ;
   expect ( 0 , 1 < 0 ) ;
   expect ( 0 , 0 > 1 ) ;
   expect ( 0 , 1 > 1 ) ;
   expect ( 0 , 1 < 1 ) ;
   expect ( 1 , 1 >= 0 ) ;
   expect ( 1 , 0 <= 1 ) ;
   expect ( 0 , 1 <= 0 ) ;
   expect ( 0 , 0 >= 1 ) ;
   expect ( 1 , 1 >= 1 ) ;
   expect ( 1 , 1 <= 1 ) ;
   "expect ( 1 , 0xFFFFFFFF > 1 )" ;
   "expect ( 1 , 1 < 0xFFFFFFFF )" ;
   "expect ( 1 , 0xFFFFFFFF >= 1 )" ;
   "expect ( 1 , 1 <= 0xFFFFFFFF )" ;
   "expect ( 1 , - 1 > 1 )" ;
   "expect ( 1 , - 1 >= 1 )" ;
   "expect ( 0 , - 1 > 1 )" ;
   "expect ( 0 , - 1 >= 1 )" ;
   "expect ( 0 , 1.0 < 0.0 )" ;
   "expect ( 1 , 0.0 < 1.0 )" ;
   done ( ) ;
}

static void test_inc_dec ( ) {
   prints ( "inc/dec" ) ; cr ( ) ;
   int a = 15 ;
   expect ( 15 , a ++ ) ;
   expect ( 16 , a ) ;
   expect ( 16 , a -- ) ;
   expect ( 15 , a ) ;
   expect ( 14 , -- a ) ;
   expect ( 14 , a ) ;
   expect ( 15 , ++ a ) ;
   expect ( 15 , a ) ;
   done ( ) ;
}

static void test_bool ( ) {
   prints ( "bool" ) ; cr ( ) ;
   expect ( 0 , ! 1 ) ;
   expect ( 1 , ! 0 ) ;
   done ( ) ;
}

static void test_ternary ( ) {
   prints ( "ternary" ) ; cr ( ) ;
   expect ( 51 , ( 1 + 2 ) ? 51 : 52 ) ;
   expect ( 52 , ( 1 - 1 ) ? 51 : 52 ) ;
   expect ( 26 , ( 1 - 1 ) ? 51 : 52 / 2 ) ;
   expect ( 17 , ( 1 - 0 ) ? 51 / 3 : 52 ) ;
   "// GNU extension" ;
   "expect ( 52 , 0 ? : 52 )" ;
   "expect ( 3 , ( 1 + 2 ) ? : 52 )" ;
   done ( ) ;
}

static void test_unary ( ) {
   prints ( "unary" ) ; cr ( ) ;
   char x = 2 ;
   short y = 2 ;
   int z = 2 ;
   expect ( - 2 , - x ) ;
   expect ( - 2 , - y ) ;
   expect ( - 2 , - z ) ;
   done ( ) ;
}

static void test_comma ( ) {
   prints ( "comma" ) ; cr ( ) ;
   expect ( 3 , ( 1 , 3 ) ) ;
   "expectf ( 7.0 , ( 1 , 3 , 5 , 7.0 ) )" ;
   "expect ( 7.0 , ( 1 , 3 , 5 , 7.0 ) )" ;
   done ( ) ;
}

void main ( ) {
   "8cc test" ;
   prints ( "basic arithmetic" ) ; cr ( ) ;
   test_basic ( ) ;
   test_relative ( ) ;
   test_inc_dec ( ) ;
   test_bool ( ) ;
   test_unary ( ) ;
   test_ternary ( ) ;
   test_comma ( ) ;
}
