: <var> CREATE CELLS ALLOT ;

: & AND ;
: ^ XOR ;
: | OR ;
: <%> MOD ;

: << LSHIFT ;
: >> RSHIFT ;
: >>> RSHIFT ;

: <=> OVER ! @ ;
: <c=> OVER C! C@ ;
: <memcpy> DUP BEGIN WHILE 1 - OVER OVER + C@ OVER 4 PICK + C! DUP REPEAT DROP DROP ;

: <@> OVER @ ;

: <+=>  <@>      +   <=> ;
: <-=>  <@> SWAP -   <=> ;
: <*=>  <@>      *   <=> ;
: </=>  <@> SWAP /   <=> ;
: <%=>  <@> SWAP <%> <=> ;
: <<<=> <@> SWAP <<  <=> ;
: <>>=> <@> SWAP >>  <=> ;
: <&=>  <@>      &   <=> ;
: <^=>  <@>      ^   <=> ;
: <|=>  <@>      |   <=> ;

: <C@> OVER C@ ;

: <c+=>  <C@>      +   <c=> ;
: <c-=>  <C@> SWAP -   <c=> ;
: <c*=>  <C@>      *   <c=> ;
: <c/=>  <C@> SWAP /   <c=> ;
: <c%=>  <C@> SWAP <%> <c=> ;
: <c<<=> <C@> SWAP <<  <c=> ;
: <c>>=> <C@> SWAP >>  <c=> ;
: <c&=>  <C@>      &   <c=> ;
: <c^=>  <C@>      ^   <c=> ;
: <c|=>  <C@>      |   <c=> ;

: <bool> IF 1 ELSE 0 THEN ;

: <[]> * + ;
: <i++> DUP @ SWAP OVER 1 + SWAP ! ;
: <i--> DUP @ SWAP OVER 1 - SWAP ! ;
: <c++> DUP C@ SWAP OVER 1 + SWAP C! ;
: <c--> DUP C@ SWAP OVER 1 - SWAP C! ;
: <++i> DUP @ 1 + OVER ! @ ;
: <--i> DUP @ 1 - OVER ! @ ;
: <++c> DUP C@ 1 + OVER ! C@ ;
: <--c> DUP C@ 1 - OVER ! C@ ;
: <-x> NEGATE ;
: <~x> INVERT ;
: <!x> 0 = <bool> ;

: <p++> OVER @ SWAP OVER      + 2 PICK ! NIP ;
: <p--> OVER @ SWAP OVER SWAP - 2 PICK ! NIP ;
: <++p> <+=> ;
: <--p> <-=> ;

: <==> = <bool> ;
: <!=> - <bool> ;
: <<> < <bool> ;
: <>> > <bool> ;
: <>=> < <~x> <bool> ;
: <<=> > <~x> <bool> ;

: printc EMIT ;
: printn . ;
: prints BEGIN DUP C@ WHILE DUP C@ EMIT 1 + REPEAT DROP ;
: putchar EMIT ;

256 <var> <local>
256 <var> <base>
1 <var> <bpx>
1 <var> <bp>

: <l> <bp> @ + ;

: <enter> <bpx> @ @ <bp> ! <bpx> @ CELL + <bpx> ! <bp> @ + <bpx> @ ! ;
: <leave> <bpx> @ CELL - <bpx> ! <bpx> @ CELL - @ <bp> ! ;
: <locals> <local> <bp> ! <base> <bpx> ! <local> <base> ! <local> <base> CELL + ! ;
